Summary: An enhanced version of csh, the C shell
Name: tcsh
Version: 6.17
Release: 2
License: BSD
Group: System Environment/Shells
URL: http://www.tcsh.org/
Source0: ftp://ftp.astron.com/pub/tcsh/%{name}-%{version}.00.tar.gz

Patch0: %{name}-%{version}.00-aix.patch
Patch2: tcsh-6.14.00-tinfo.patch
Patch3: tcsh-6.14.00-unprintable.patch
Patch4: tcsh-6.15.00-hist-sub.patch
Patch6: tcsh-6.15.00-ca-color.patch
Patch7: tcsh-6.14.00-set.patch
Patch8: tcsh-6.14.00-syntax.patch
Patch9: tcsh-6.13.00-memoryuse.patch
Patch11: tcsh-6.14.00-order.patch
Patch12: tcsh-6.15.00-rs-color.patch
Patch13: tcsh-6.17.00-mh-color.patch
# The idea is good, but the patch must be rewritten to be accepted by upstream
# (see tcsh mailing list for more information):
Patch14: tcsh-6.17.00-glob-automount.patch
# Accepted by upstream:
Patch15: tcsh-6.17.00-history.patch
# Accepted by upstream:
Patch16: tcsh-6.17.00-printexitvalue.patch
Patch17: tcsh-6.17.00-testsuite.patch
# Accepted by upstream:
Patch18: tcsh-6.17.00-extrafork.patch
# Proposed to upstream: http://bugs.gw.com/view.php?id=109
Patch19: tcsh-6.17.00-wait-intr.patch
# Proposed to upstream: http://bugs.gw.com/view.php?id=110
Patch20: tcsh-6.14.00-pipeexit.patch

Provides: csh = %{version}
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: autoconf, automake, patch, coreutils
BuildRequires: libiconv >= 1.14-2
Requires: libiconv >= 1.14-2

%description
Tcsh is an enhanced but completely compatible version of csh, the C
shell.  Tcsh is a command language interpreter which can be used both
as an interactive login shell and as a shell script command processor.
Tcsh includes a command line editor, programmable word completion,
spelling correction, a history mechanism, job control and a C language
like syntax.


%prep
%setup -q -n %{name}-%{version}.00
export PATH=/opt/freeware/bin:$PATH
%patch2 -p1 -b .tinfo
%patch3 -p1 -b .unprintable
%patch4 -p1 -b .hist-sub
%patch6 -p1 -b .ca-color
%patch7 -p1 -b .set
%patch8 -p1 -b .syntax
%patch9 -p1 -b .memoryuse
%patch11 -p1 -b .order
%patch12 -p1 -b .rs-color
%patch13 -p1 -b .mh-color
%patch14 -p1 -b .glob-automount
%patch15 -p1 -b .history
%patch16 -p1 -b .printexitvalue
%patch17 -p1 -b .testsuite
%patch18 -p1 -b .extrafork
%patch19 -p1 -b .wait-intr
%patch20 -p1 -b .pipeexit
%patch0


%build
# For tcsh-6.14.00-tinfo.patch
autoreconf
export CC=xlc_r
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --with-libiconv-prefix=%{_prefix} \
    --without-hesiod
make %{?_smp_mflags} all LIBES=-lcurses


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
export PATH=/opt/freeware/bin:$PATH

mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1 ${RPM_BUILD_ROOT}%{_bindir}
install -p -m 755 tcsh ${RPM_BUILD_ROOT}%{_bindir}/tcsh
install -p -m 644 tcsh.man ${RPM_BUILD_ROOT}%{_mandir}/man1/tcsh.1

(
  cd ${RPM_BUILD_ROOT}
  mkdir -p usr/bin
  mkdir -p usr/linux/bin
  cd usr/bin
  ln -sf ../..%{_bindir}/tcsh .
  cd ../linux/bin
  ln -sf ../../..%{_bindir}/tcsh csh
)


%post
if [ ! -f /etc/shells ]; then
    echo "%{_bindir}/tcsh" >> /etc/shells
    echo "%{_bindir}/csh"  >> /etc/shells
else
    grep -q '^%{_bindir}/tcsh$' /etc/shells || \
        echo "%{_bindir}/tcsh" >> /etc/shells
    grep -q '^%{_bindir}/csh$'  /etc/shells || \
         echo "%{_bindir}/csh" >> /etc/shells
fi


%postun
if [ ! -x %{_bindir}/tcsh ]; then
    grep -v '^%{_bindir}/tcsh$' /etc/shells | \
        grep -v '^%{_bindir}/csh$' > /etc/shells.rpm && \
        mv /etc/shells.rpm /etc/shells
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc BUGS FAQ Fixes NewThings WishList complete.tcsh README
%{_bindir}/*
%{_mandir}/man1/*.1
/usr/bin/tcsh
/usr/linux/bin/csh


%changelog
* Mon Feb 18 2013 Michael Perzl <michael@perzl.org> - 6.17-2
- dropped the Linux-related 'closem' patch
- changed the definition of NOFILE for AIX in order to speed up the startup
  time by avoiding useless "EBADF" ("bad file descriptor") errors

* Mon Jan 10 2011 Michael Perzl <michael@perzl.org> - 6.17-1
- first version for AIX V5.1 and higher based on the Fedora 15 version 6.17-10
